<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Document</title>
  </head>
  <body>
    <button onclick="runningSum([3, 1, 2, 10, 1])">reduce</button>
  </body>
  <script>
    var runningSum = function (nums) {
      // EACH ELEMENT IS THE SUM OF ITSELF PLUS ALL THE PREVIOUS ELEMENTS
      let sum = 0;
      let prev_elems = [];
      let result = [];

      for (let i = 0; i < nums.length; i++) {
        debugger;
        prev_elems.push(nums[i]);
        result.push(nums[i] + prev_elems.reduce((a, b) => a + b, 0) - nums[i]);
      }
      console.log("🚀 ~ file: reduce.html ~ line 26 ~ runningSum ~ result", result)
      return result;
    };

    // runningSum([3, 1, 2, 10, 1]); // [ 3, 4, 6, 16, 17 ]
  </script>
</html>
